
/*******************************************************************************

Copyright (c) 2008 - 2018 ӢʱƼ޹˾Ȩ

*******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

typedef unsigned char BYTE;
typedef long BOOL;

#define FALSE	0
#define TRUE	1


#define MAX_LINE_LENGTH		256		// һджٸַ
#define MAX_LINE_COUNT		1024	// Դļж

#define MAX_SYMBOL_LENGTH	64		// һ԰ٸַ
#define MAX_SYMBOL_COUNT	256		// Դļ԰ٸ

#ifndef MAX_PATH
#define MAX_PATH 256				// ļ·԰ַ
#endif


// ݿ⡣¼ԴļдеϢעСУ
struct LINE_RECORD
{
	char line_string[MAX_LINE_LENGTH];	// е
	unsigned long line_num;				// к
	unsigned long address;				// дתĻӳļеĵַƫƣע⣬ DM1000 ˵΢ָһַӦ 4 ֽڡ
	int machine_code_count;				// дתĻֽ
	unsigned long flag;					// б־λ32λ
};
struct LINE_RECORD line_database[MAX_LINE_COUNT] = { 0 };
int line_count = 0;
int machine_code_line_count = 0;	// ¼˻Ĵе

									// ڴ˶еĴб־λע⣬б־λǰλĹϵ
#define LF_INSTRUCTION		0x00000001		// б־λλ1ʾһָʾ

									//
									// 涨еĹؼ
									//

									// Ĵ
const char* rs_register_keyword = "rs";
const char* rd_register_keyword = "rd";

const char* al_register_keyword = "al";
const char* dl_register_keyword = "dl";
const char* sp_register_keyword = "sp";
const char* es_register_keyword = "es";

const char* flag_register_keyword = "flag";

const char* mar_register_keyword = "mar";
const char* ir_register_keyword = "ir";
const char* a_register_keyword = "a";
const char* w_register_keyword = "w";

const char* pc_register_keyword = "pc";
const char* upc_register_keyword = "upc";

//
// alu 
const char* alu_add_keyword = "alu_add";
const char* alu_adc_keyword = "alu_adc";
const char* alu_sub_keyword = "alu_sub";
const char* alu_sbb_keyword = "alu_sbb";
const char* alu_and_keyword = "alu_and";
const char* alu_or_keyword = "alu_or";
const char* alu_xor_keyword = "alu_xor";

const char* alu_inc_keyword = "alu_inc";
const char* alu_dec_keyword = "alu_dec";

const char* alu_shr_keyword = "alu_shr";
const char* alu_shl_keyword = "alu_shl";
const char* alu_rcr_keyword = "alu_rcr";
const char* alu_rcl_keyword = "alu_rcl";

const char* alu_sal_keyword = "alu_sal";
const char* alu_sar_keyword = "alu_sar";
const char* alu_rol_keyword = "alu_rol";
const char* alu_ror_keyword = "alu_ror";
const char* alu_not_keyword = "alu_not";

const char* al_flag_keyword = "al_flag";
const char* shift_flag_keyword = "shift_flag";

// Ĳ
const char* pc_main_memory_keyword = "[pc]";
const char* jz_mar_keyword = "jz[mar]";
const char* jnz_mar_keyword = "jnz[mar]";
const char* jc_mar_keyword = "jc[mar]";

const char* ja_mar_keyword = "ja[mar]";
const char* jb_mar_keyword = "jb[mar]";
const char* jg_mar_keyword = "jg[mar]";
const char* jl_mar_keyword = "jl[mar]";
const char* jmp_mar_keyword = "jmp[mar]";
const char* mar_main_memory_keyword = "[mar]";
const char* mar_extern_IO_keyword = "<mar>";
const char* int_number_keyword = "inta";


const char* delimit_char = "\n\t\r ";			// ҪԵĿհַ
const char* delimit_char_comma = "\n\t\r, ";	// ҪԵĿհַӢĶ


												// ΢ָ
struct ONE_OPERAND_INSTRUCTION_ENTRY
{
	const char** op;
	unsigned long micro_machine_code;
};

struct ONE_OPERAND_INSTRUCTION_ENTRY one_operand_table[] =
{
	{ NULL,						0x0 }	// δ

	,{ &pc_register_keyword,		0xfffffffd } // inc pc
	,{ &upc_register_keyword,		0xffffffc3 } // reset upc
};


// Ƿƥ䡣0ƥ䣻ط0ƥ䣬ҷֵǲڱе±ꡣ
int match_one_operand(const char* op)
{
	int i;

	for (i = 1; i<sizeof(one_operand_table) / sizeof(one_operand_table[0]); i++)
	{
		if ((stricmp(op, *one_operand_table[i].op) == 0))
		{
			return i;
		}
	}

	return 0;
}


// ˫΢ָ
struct PATH_INSTRUCTION_OPERAND_ENTRY
{
	const char** op1;
	const char** op2;
	unsigned long micro_machine_code;
};


//////////////////////////////////////////////////////////////////////////
//
struct PATH_INSTRUCTION_OPERAND_ENTRY path_operand_table[] =
{
	{ NULL,								NULL,							0x0 }	// δ

	,{ &pc_main_memory_keyword,			&ir_register_keyword,			0xffef47ff } // path [pc], ir		
	,{ &pc_main_memory_keyword,			&rd_register_keyword,			0xffe947ff } // path [pc], rd	
	,{ &pc_main_memory_keyword,			&mar_register_keyword,			0xffe547ff } // path [pc], mar
	,{ &pc_main_memory_keyword,			&a_register_keyword,			0xffe147ff } // path [pc], a
	,{ &pc_main_memory_keyword,			&w_register_keyword,			0xffe347ff } // path [pc], w

	,{ &jz_mar_keyword,					&pc_register_keyword,			0xff1f86fd } // path jz[mar], pc
	,{ &jnz_mar_keyword,				&pc_register_keyword,			0xff3f86fd } // path jnz[mar], pc
	,{ &jc_mar_keyword,					&pc_register_keyword,			0xff5f86fd } // path jc[mar], pc
	,{ &ja_mar_keyword,					&pc_register_keyword,			0xff7f86fd } // path ja[mar], pc
	,{ &jb_mar_keyword,					&pc_register_keyword,			0xff9f86fd } // path jb[mar], pc
	,{ &jg_mar_keyword,					&pc_register_keyword,			0xffbf86fd } // path jg[mar], pc
	,{ &jl_mar_keyword,					&pc_register_keyword,			0xffdf86fd } // path jl[mar], pc
	,{ &jmp_mar_keyword,				&pc_register_keyword,			0xffff86fd } // path jmp[mar], pc

	,{ &rs_register_keyword,			&rd_register_keyword,			0xffe9c1ff } // path rs, rd
	,{ &rs_register_keyword,			&w_register_keyword,			0xffe3c1ff } // path rs, w
	,{ &rs_register_keyword,			&mar_register_keyword,			0xffe5c1ff } // path rs, mar
	,{ &rd_register_keyword,			&mar_register_keyword,			0xffe5c1bf } // path rd, mar
	,{ &rs_register_keyword,			&mar_main_memory_keyword,		0xffe781ff } // path rs, [mar]
	,{ &rs_register_keyword,			&mar_extern_IO_keyword,		    0xffe781fe } // path rs, <mar>
	,{ &int_number_keyword,				&w_register_keyword,		    0xffe3c7ce } // path inta, w
	,{ &int_number_keyword,				&mar_register_keyword,		    0xffe5c7ce } // path inta, mar

	,{ &flag_register_keyword,			&mar_main_memory_keyword,		0xffe783ff } // path flag,[mar]
	,{ &a_register_keyword,				&mar_main_memory_keyword,		0xffe791ff } // path a,   [mar]
	,{ &pc_register_keyword,			&mar_main_memory_keyword,		0xffe785ff } // path pc,  [mar]
	,{ &a_register_keyword,				&pc_register_keyword,		    0xffffd0ff } // path a, pc

	,{ &rd_register_keyword,			&a_register_keyword,			0xffe1c1bf } // path rd, a
	,{ &rd_register_keyword,			&w_register_keyword,			0xffe3c1bf } // path rd, w
	,{ &pc_register_keyword,			&a_register_keyword,			0xffe1c5ff } // path pc, a
	,{ &pc_register_keyword,			&mar_register_keyword,			0xffe5c5ff } // path pc, mar
	,{ &es_register_keyword,			&a_register_keyword,			0xffe1c1ff } // path es, a
	,{ &sp_register_keyword,			&a_register_keyword,			0xffe1c1bf } // path sp, a
	,{ &sp_register_keyword,			&w_register_keyword,			0xffe3c1bf } // path sp, w
	,{ &sp_register_keyword,			&mar_register_keyword,			0xffe5c1bf } // path sp, mar

	,{ &mar_main_memory_keyword,		&w_register_keyword,			0xffe387ff } // path [mar], w
	,{ &mar_main_memory_keyword,		&rd_register_keyword,			0xffe987ff } // path [mar], rd
	,{ &mar_main_memory_keyword,		&pc_register_keyword,			0xffff86ff } // path [mar], pc
	,{ &mar_main_memory_keyword,		&flag_register_keyword,			0xffeb87ff } // path [mar], flag
	,{ &mar_extern_IO_keyword,			&rd_register_keyword,			0xffe987fe } // path <mar>, rd

	,{ &al_flag_keyword,				&flag_register_keyword,			0xffebcbff } // path al_flag, flag	
	,{ &shift_flag_keyword,				&flag_register_keyword,			0xffebd3ff } // path shift_flag, flag	


	,{ &alu_add_keyword,				&rd_register_keyword,			0xd9e9d1ff } // path alu_add, rd	
	,{ &alu_sub_keyword,				&rd_register_keyword,			0xd6e9d1ff } // path alu_sub, rd	
	,{ &alu_adc_keyword,				&rd_register_keyword,			0xc9e9d1ff } // path alu_adc, rd
	,{ &alu_sbb_keyword,				&rd_register_keyword,			0xc6e9d1ff } // path alu_sbb, rd

	,{ &alu_or_keyword,					&rd_register_keyword,			0xfee9d1ff } // path alu_or, rd
	,{ &alu_and_keyword,				&rd_register_keyword,			0xfbe9d1ff } // path alu_and, rd
	,{ &alu_xor_keyword,				&rd_register_keyword,			0xf6e9d1ff } // path alu_xor, rd
	,{ &alu_not_keyword,				&rd_register_keyword,			0xf0e9d1ff } // path alu_not, rd


	,{ &alu_inc_keyword,				&rd_register_keyword,			0xd0e9d1ff } // path alu_inc, rd
	,{ &alu_dec_keyword,				&rd_register_keyword,			0xdfe9d1ff } // path alu_dec, rd
	,{ &alu_sub_keyword,				&a_register_keyword,			0xd6e1d1ff } // path alu_sub, a
	,{ &alu_inc_keyword,				&a_register_keyword,			0xd0e1d1ff } // path alu_inc, a

	,{ &alu_add_keyword,				&mar_register_keyword,			0xd9e5d1ff } // path alu_add, mar
	,{ &alu_inc_keyword,				&mar_register_keyword,			0xd0e5d1ff } // path alu_inc, mar

	,{ &alu_dec_keyword,				&sp_register_keyword,			0xdfe9d1ff } // path alu_dec, sp
	,{ &alu_inc_keyword,				&sp_register_keyword,			0xd0e9d1ff } // path alu_inc, sp

	,{ &alu_shr_keyword,				&rd_register_keyword,			0x3fe9c9ff } // path alu_shr, rd	 
	,{ &alu_shl_keyword,				&rd_register_keyword,			0x3fe8c9ff } // path alu_shl, rd
	,{ &alu_rcr_keyword,				&rd_register_keyword,			0xffe9c9ff } // path alu_rcr, rd
	,{ &alu_rcl_keyword,				&rd_register_keyword,			0xffe8c9ff } // path alu_rcl, rd
	,{ &alu_sal_keyword,				&rd_register_keyword,			0x7fe8c9ff } // path alu_sal, rd	 
	,{ &alu_sar_keyword,				&rd_register_keyword,			0x7fe9c9ff } // path alu_sar, rd
	,{ &alu_rol_keyword,				&rd_register_keyword,			0xbfe8c9ff } // path alu_rol, rd
	,{ &alu_ror_keyword,				&rd_register_keyword,			0xbfe9c9ff } // path alu_ror, rd

};


// жǷƥ䡣0ȫƥ䣻ط0ȫƥ䣬ҷֵǲڱе±ꡣ
int match_ops(const char* op1, const char* op2)
{
	int i;

	for (i = 1; i<sizeof(path_operand_table) / sizeof(path_operand_table[0]); i++)
	{
		if ((stricmp(op1, *path_operand_table[i].op1) == 0)
			&& (stricmp(op2, *path_operand_table[i].op2) == 0))
		{
			return i;
		}
	}

	return 0;
}

// Ļ
#define MAX_MACHINE_CODE 1024
BYTE machine_code[MAX_MACHINE_CODE];
unsigned long machine_code_address = 0;		// һַӦһֽ
unsigned long machine_code_old_address = 0;


const char* micro_file_name = NULL;				// ΢ָļ·
const char* target_file_name = NULL;			// Ŀļ·
const char* list_file_name = NULL;				// бļ·
const char* dbg_file_name = NULL;				// Ϣļ·

const unsigned long dbg_file_magic = 58;
const unsigned long dbg_file_version = 1;


// зֵ﷨Ϣ
void error_msg(const char* error_msg, int line_num)
{
	if (line_num >= 1)
	{
		printf("%s:%d: error: %s\n", micro_file_name, line_num, error_msg);
	}
	else
	{
		printf("%s: error: %s\n", micro_file_name, error_msg);
	}

	exit(1);
}



char formated_msg[1024];	// ʽĴϢڴַС
void error_msg_miss_op(const char* instruction_name, int line_num)
{
	sprintf(formated_msg, "%s ָȱٲ", instruction_name);
	error_msg(formated_msg, line_num);
}

void error_msg_wrong_op(const char* instruction_name, int line_num)
{
	sprintf(formated_msg, "%s ָ֧Ĳ", instruction_name);
	error_msg(formated_msg, line_num);
}


// ؼֺͽĶӦϵ
typedef void(*PARSE_FUNCTION)(int line_num);
struct KEYWORD_FUNCTION_ENTRY
{
	const char** keyword;
	PARSE_FUNCTION parse_function;
};

// ָ
const char* fetch_instruction_keyword = "fetch";
const char* check_instruction_keyword = "check";
const char* cli_instruction_keyword = "cli";
const char* sti_instruction_keyword = "sti";
const char* inta_instruction_keyword = "inta";
const char* dup_instruction_keyword = "dup";
const char* null_instruction_keyword = "null";
const char* path_instruction_keyword = "path";

const char* inc_instruction_keyword = "inc";
const char* reset_instruction_keyword = "reset"; // λ

												 // жǷָ֧
int is_immediate(const char* token)
{
	return isdigit(token[0]);
}

// õֵָ֧
unsigned long get_value_from_immediate(const char* immediate)
{
	char* end;
	int base = (immediate[0] == '0' && (immediate[1] == 'x' || immediate[1] == 'X')) ? 16 : 10;
	return strtoul(immediate, &end, base);
}

// dup n, null
void parse_dup(int line_num)
{
	char *op1, *op2;
	int i;
	unsigned long micro_instruction_count;	// ΢ָ
	unsigned long micro_code;				// ΢ָ

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char);

	if (NULL == op1 || NULL == op2)
	{
		error_msg_miss_op(dup_instruction_keyword, line_num);
	}

	// dup΢ָĵһ(ʮƻʮ)
	if (!is_immediate(op1))
	{
		error_msg_wrong_op(dup_instruction_keyword, line_num);
	}

	// õ΢ָ
	micro_instruction_count = get_value_from_immediate(op1);

	// ڶ
	if (is_immediate(op2))
	{
		micro_code = get_value_from_immediate(op2);
	}
	else if (0 == stricmp(op2, null_instruction_keyword))
	{
		micro_code = 0xffffffff;
	}
	else
	{
		error_msg_wrong_op(dup_instruction_keyword, line_num);
	}

	for (i = 0; i < (int)micro_instruction_count; i++)
	{
		memcpy(&machine_code[machine_code_address], &micro_code, 4);
		machine_code_address += 4;
	}
}

// fetch
void parse_fetch(int line_num)
{
	unsigned long ul = 0xffff47c7;
	memcpy(&machine_code[machine_code_address], &ul, 4);
	machine_code_address += 4;
}


// check
void parse_check(int line_num)
{
	unsigned long ul = 0xffffffcb;
	memcpy(&machine_code[machine_code_address], &ul, 4);
	machine_code_address += 4;
}

// cli
void parse_cli(int line_num)
{
	unsigned long ul = 0xffffffd3;
	memcpy(&machine_code[machine_code_address], &ul, 4);
	machine_code_address += 4;
}

// sti
void parse_sti(int line_num)
{
	unsigned long ul = 0xffffffd7;
	memcpy(&machine_code[machine_code_address], &ul, 4);
	machine_code_address += 4;
}

// inta
void parse_inta(int line_num)
{
	unsigned long ul = 0xffffffcf;
	memcpy(&machine_code[machine_code_address], &ul, 4);
	machine_code_address += 4;
}


// null
void parse_null(int line_num)
{
	unsigned long ul = 0xffffffff;
	memcpy(&machine_code[machine_code_address], &ul, 4);
	machine_code_address += 4;
}


// path op1, op2
void parse_path(int line_num)
{
	char *op1, *op2;
	int index;

	op1 = strtok(NULL, delimit_char_comma);
	op2 = strtok(NULL, delimit_char);

	if (NULL == op1 || NULL == op2)
	{
		error_msg_miss_op(path_instruction_keyword, line_num);
	}

	index = match_ops(op1, op2);
	if (0 == index)
	{
		error_msg_wrong_op(path_instruction_keyword, line_num);
	}

	memcpy(&machine_code[machine_code_address], &path_operand_table[index].micro_machine_code, 4);
	machine_code_address += 4;

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}

// inc 
void parse_inc(int line_num)
{
	char *op;
	int index;

	op = strtok(NULL, delimit_char_comma);
	if (NULL == op)
	{
		error_msg_miss_op(inc_instruction_keyword, line_num);
	}

	index = match_one_operand(op);
	if (0 == index)
	{
		error_msg_wrong_op(inc_instruction_keyword, line_num);
	}

	memcpy(&machine_code[machine_code_address], &one_operand_table[index].micro_machine_code, 4);
	machine_code_address += 4;

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}


// reset 
void parse_reset(int line_num)
{
	char *op;
	int index;

	op = strtok(NULL, delimit_char_comma);
	if (NULL == op)
	{
		error_msg_miss_op(reset_instruction_keyword, line_num);
	}

	index = match_one_operand(op);
	if (0 == index)
	{
		error_msg_wrong_op(reset_instruction_keyword, line_num);
	}

	memcpy(&machine_code[machine_code_address], &one_operand_table[index].micro_machine_code, 4);
	machine_code_address += 4;

	//
	// ڴݿУǴһָ
	//
	line_database[line_count].flag |= LF_INSTRUCTION;
}


//
// 뽫ؼּıСӶʹáıģʽ
//
struct KEYWORD_FUNCTION_ENTRY keyword_function_table[] =
{
	{ NULL,								NULL }	// δ

	,{ &fetch_instruction_keyword,			parse_fetch }
	,{ &check_instruction_keyword,			parse_check }
	,{ &dup_instruction_keyword,			parse_dup }
	,{ &cli_instruction_keyword,			parse_cli }
	,{ &sti_instruction_keyword,			parse_sti }
	,{ &inta_instruction_keyword,			parse_inta }
	,{ &null_instruction_keyword,			parse_null }
	,{ &path_instruction_keyword,			parse_path }
	,{ &inc_instruction_keyword,			parse_inc }
	,{ &reset_instruction_keyword,			parse_reset }
};



// жǷһؼ֡0ǹؼ֣ط0ǹؼ֣ҷֵǹؼڱе±ꡣ
int match_keyword(const char* token)
{
	int i;

	for (i = 1; i<sizeof(keyword_function_table) / sizeof(keyword_function_table[0]); i++)
	{
		if (stricmp(token, *keyword_function_table[i].keyword) == 0)
		{
			return i;
		}
	}

	return 0;
}


// 汾Ϣ
void version_msg()
{
	printf(
		"8086΢ָ [汾 2.0]\n"
		"Ȩ (c) 2008-2018 ӢʱƼ޹˾Ȩ\n"
	);
}

// Ϣ
void help_msg()
{
	printf(
		"8086΢ָ\n\n"
		"÷:\n\n"
		"  microasm.exe micro_file_name [options]\n\n"
		"ѡ:\n\n"
		"  -g debug_file_name\tָɵĵϢļ·\n"
		"  -h\t\t\tӡ˰Ϣ\n"
		"  -l list_file_name\tָɵбļ·\n"
		"  -o target_file_name\tָɵĿļ·δָĬ micro.obj ļ\n"
		"  -v\t\t\tӡ汾Ϣ\n"
	);

	printf("\n");

	version_msg();

	exit(1);
}

void argument_error_msg()
{
	printf("в\n\n");
	help_msg();
}

// ûв
void process_argument(int argc, char* argv[])
{
	int i;

	// argv[0]  "easm.exe"ԿԺԡ
	for (i = 1; i<argc; i++)
	{
		if (strcmp(argv[i], "-v") == 0)
		{
			version_msg();
			exit(1);
		}
		else if (strcmp(argv[i], "-h") == 0)
		{
			help_msg();
		}
		else if (strcmp(argv[i], "-o") == 0)
		{
			if (i + 1 < argc)
			{
				i++;
				target_file_name = argv[i];
			}
			else
			{
				argument_error_msg();
			}
		}
		else if (strcmp(argv[i], "-l") == 0)
		{
			if (i + 1 < argc)
			{
				i++;
				list_file_name = argv[i];
			}
			else
			{
				argument_error_msg();
			}
		}
		else if (strcmp(argv[i], "-g") == 0)
		{
			if (i + 1 < argc)
			{
				i++;
				dbg_file_name = argv[i];
			}
			else
			{
				argument_error_msg();
			}
		}
		else if (NULL == micro_file_name && argv[i][0] != '-')
		{
			// ĻԴļ·
			micro_file_name = argv[i];
		}
		else
		{
			argument_error_msg();
		}
	}

	//
	// вûָĻļʹӡϢ˳
	//
	if (NULL == micro_file_name)
	{
		printf("вûָ΢ָԴļ·\n");
		help_msg();
	}
}

// һַдļСȽַдļȻַе
// ÿַдļַĩβ 0.
void write_string_to_binary_file(const char* str, FILE* fp)
{
	int str_length;

	if (str != NULL)
	{
		str_length = strlen(str);
		fwrite(&str_length, 1, sizeof(str_length), fp);
		fwrite(str, 1, str_length, fp);
	}
	else
	{
		str_length = 0;
		fwrite(&str_length, 1, sizeof(str_length), fp);
	}
}


int main(int argc, char* argv[])
{
	FILE* fp;
	char* token;
	char line[MAX_LINE_LENGTH];
	int i, j;
	int line_num = 1;	// кŴӵһпʼ
	int keyword_index;
	unsigned long micro_code;

	//
	// в
	//
	process_argument(argc, argv);

	//
	// 򿪻Դļ
	//
	fp = fopen(micro_file_name, "r");
	if (NULL == fp)
	{
		printf("޷΢ָԴļ %s\n", micro_file_name);
		return 1;
	}

	////////////////////////////////////////////////////////////////////////////
	//// ɨ

	version_msg();
	printf("\nڻ %s...\n", micro_file_name);

	//
	// һζȡһıͬʱ¼еĴϢ
	//
	while (fgets(line, sizeof(line), fp) != NULL)
	{
		//
		// һдϢ¼ݿ
		//
		strcpy(line_database[line_count].line_string, line);
		line_database[line_count].line_num = line_num;
		line_database[line_count].address = machine_code_address;

		//
		// еעͰ
		//
		line[strcspn(line, ";")] = 0;

		//
		// ʼ
		//
		token = strtok(line, delimit_char);
		if (NULL == token)
		{
			// ǿУκδ
		}
		else if ((keyword_index = match_keyword(token)) != 0)
		{
			// ݹؼֽӦĴ
			keyword_function_table[keyword_index].parse_function(line_num);
		}
		else if (is_immediate(token))
		{
			// ֱΪ΢ָ
			micro_code = get_value_from_immediate(token);

			memcpy(&machine_code[machine_code_address], &micro_code, 4);
			machine_code_address += 4;
		}
		else
		{
			error_msg("޷ʶĴС", line_num);
		}

		//
		// ݿϢ
		//
		line_database[line_count].machine_code_count = machine_code_address - machine_code_old_address;
		machine_code_old_address = machine_code_address;

		//
		// ¼˻Ĵ
		//
		if (line_database[line_count].machine_code_count != 0)
		{
			machine_code_line_count++;
		}

		//
		// к
		//
		line_count++;
		line_num++;

		if (line_count == MAX_LINE_COUNT)
		{
			sprintf(formated_msg, "΢ָļеĴйֻ࣬ %d д롣", MAX_LINE_COUNT);
			error_msg(formated_msg, -1);
		}
	}

	fclose(fp);

	////////////////////////////////////////////////////////////////////////////
	//// ļ

	//
	// дļ
	//
	if (NULL == target_file_name)
	{
		target_file_name = "micro.obj";
	}

	fp = fopen(target_file_name, "wb");
	if (NULL == fp)
	{
		printf("޷Ŀļ %s\n", target_file_name);
		return 1;
	}

	fwrite(machine_code, 1, machine_code_address, fp);

	fclose(fp);

	printf("\nĿļ %s\n", target_file_name);

	//
	// ݿеϢдбļ
	//
	if (list_file_name != NULL)
	{
		fp = fopen(list_file_name, "w");
		if (NULL == fp)
		{
			printf("޷бļ %s\n", list_file_name);
			return 1;
		}

		for (i = 0; i<line_count; i++)
		{
			// к
			fprintf(fp, "%04d    ", line_database[i].line_num);

			// ַͻ
			if (line_database[i].machine_code_count > 0)
			{
				fprintf(fp, "%02X    ", line_database[i].address);

				for (j = 0; j<4; j++)
				{
					fprintf(fp, "%02X ", machine_code[line_database[i].address + j]);
				}

				fprintf(fp, "  ");
			}
			else
			{
				fprintf(fp, "                    ");
			}

			// Դ
			fprintf(fp, line_database[i].line_string);
		}

		fclose(fp);

		printf("бļ %s\n", list_file_name);
	}

	//
	// ݿеϢдƵĵϢļ
	//
	// ϢĻʽΪ
	// ħ4ֽڣ̶ɸı
	// 汾ţ4ֽڣ̶ɸı
	// Դļ·ַȣ4ֽڣ
	// Դļ·ַַβ0
	// бļ·ַȣ4ֽڣ
	// бļ·ַַβ0
	//
	// ݿԪص4ֽڣ
	// ݿеԪ
	//
	// űԪص4ֽڣ
	// űеԪ
	//

	if (dbg_file_name != NULL)
	{
		fp = fopen(dbg_file_name, "wb");
		if (NULL == fp)
		{
			printf("޷򿪵Ϣļ %s\n", dbg_file_name);
			return 1;
		}

		// ħ
		fwrite(&dbg_file_magic, 1, sizeof(dbg_file_magic), fp);

		// 汾
		fwrite(&dbg_file_version, 1, sizeof(dbg_file_version), fp);

		// Դļ·
		write_string_to_binary_file(micro_file_name, fp);

		// бļ·
		write_string_to_binary_file(list_file_name, fp);

		// ݿеԪ
		fwrite(&machine_code_line_count, 1, sizeof(machine_code_line_count), fp);
		for (i = 0; i<line_count; i++)
		{
			// ûвĴ
			if (0 == line_database[i].machine_code_count)
			{
				continue;
			}

			fwrite(&line_database[i].line_num, 1, sizeof(unsigned long), fp);
			fwrite(&line_database[i].address, 1, sizeof(unsigned long), fp);
			fwrite(&line_database[i].machine_code_count, 1, sizeof(int), fp);
			fwrite(&line_database[i].flag, 1, sizeof(unsigned long), fp);
		}

		// ûзűΪȷϢĸʽܹȷȡдűΪ 0
		i = 0;
		fwrite(&i, 1, sizeof(i), fp);
		fclose(fp);

		printf("ɵϢļ %s\n", dbg_file_name);
	}

	return 0;
}
